// -------------------------------------------->>
// classicSnake
//
// Developed by: Alexandre Martins (@leX)
//  2003
// www.gamingbrasil.net
// =============================
// food.cpp
// Object "food"
// -------------------------------------------->>

#include "classicSnake.h"

_food food;


// ----------------------->>
// init()
// Initializes _food
// ----------------------->>
void _food :: init(){

    char tempstr[30];
    
    // Loading "eat" sample
    sprintf(tempstr,"%s\\food.wav",SFX_DIR);
    if((eat=load_sample(tempstr))==NULL){
        allegro_message("File \"%s\" doesn\'t exist");
        game.forceExit(1);
    }

    // Creating a bitmap
    bmp=create_bitmap(FOOD_WIDTH,FOOD_HEIGHT);
    clear_to_color(bmp,makecol(255,0,0));
    
    // Changing position
    changePosition();
    
}




// ---------------------->>
// destroy()
// Destroys _food
// ---------------------->>
void _food :: destroy(){

    // Destroying "eat" sample
    stop_sample(eat);
    destroy_sample(eat);

    // Destroying bmp    
    destroy_bitmap(bmp);
    
}




// ------------------------>>
// changePosition()
// changes food position
// ------------------------>>
void _food :: changePosition(){

    x=game.random(SCREEN_W/FOOD_WIDTH);
    y=game.random((SCREEN_H/FOOD_HEIGHT)-2);
    
}



// ---------------------------->>
// hitTest()
// Checks for collision
// ---------------------------->>
bool _food :: hitTest(int bx, int by){

    if(x==bx && y==by) return true;
    else return false;
    
}



// ------------------------->>
// draw()
// Drawing functions
// ------------------------->>
void _food :: draw(){

    blit(bmp,game.buffer,0,0,x*FOOD_WIDTH,y*FOOD_HEIGHT,FOOD_WIDTH,FOOD_HEIGHT);
    
}
