// -------------------------------------------->>
// classicSnake
//
// Developed by: Alexandre Martins (@leX)
//  2003
// www.gamingbrasil.net
// =============================
// game.h
// Object "game" - header file
// -------------------------------------------->>

#ifndef GAME_H
#define GAME_H

// ----------------->>
// Constants
// ----------------->>
// directories
#define GFX_DIR               "gfx"
#define MUSIC_DIR             "music"
#define SFX_DIR               "sfx"

// global values
#define GV_RUN_ONCE           0   // This event will run only ONCE
#define GV_RUN_WHILE_FALSE    1   // This will run while false
#define GV_FRAME              2   // Current frame
#define GV_ACTUAL_STAGE       3   // Actual stage
#define GV_SCORE              4   // Score

// frames
#define FRAME_INTRO           0   // Introduction
#define FRAME_PLAYING         1   // Playing
#define FRAME_GAMEOVER        2   // GameOver screen
#define FRAME_CLEAR           3   // game clear

// ----------------->>
// class _game
// ----------------->>
class _game{

    public:

    // ** Playing related **
    bool playing;           // if playing==false, the game is closed
    int global[16];         // global variables
    void init();            // initialize functions
    void close();           // exit functions
    void forceExit(int n);  // forces the game to exit
    void askExit();         // Do you really want to exit? (Y/N)
    void logicloop();       // logic loop
    void runWhileFalse();   // This will run once each time global[GV_FRAME]=FRAME_PLAYING
    void gameClear();       // game clear
    void intro();           // Introduction
    
    // ** Gfx related **
    BITMAP *buffer;       // game buffer
    void drawScreen();    // draws the screen
    
    // ** General **
    void randomize();       // randomize
    int random(int num);    // returns a random number
    void readStr(FILE *fp, char str[]); // reads a string in file fp between two '\"'
    void highcolor_fade_out(int speed); // fade out effect
    
};


#endif
