// -------------------------------------------->>
// classicSnake
//
// Developed by: Alexandre Martins (@leX)
//  2003
// www.gamingbrasil.net
// =============================
// snake.h
// Object "snake" - header file
// -------------------------------------------->>

#ifndef SNAKE_H
#define SNAKE_H

// ------------------>>
// Constants
// ------------------>>
#define SNAKE_WIDTH      10
#define SNAKE_HEIGHT     10
#define SNAKE_DIR_UP     0
#define SNAKE_DIR_RIGHT  1
#define SNAKE_DIR_DOWN   2
#define SNAKE_DIR_LEFT   3


// ---------------------->>
// class _snakeTail
// ---------------------->>
class _snakeTail{

    public:
    
    int x,y;   // position
    
};


// -------------------->>
// class _snakeBody
// -------------------->>
class _snakeBody{

    public:

    _snakeBody *next;
    _snakeBody *prev;
    
    int oldBX, oldBY; // old position
    int x, y;         // actual position
    
};





// ---------------------->>
// class _snake
// ---------------------->>
class _snake{

    private:
    
    int snakeTimer;   // controls the speed
    int oldHX,oldHY;  // stores old head position
    int gotoX,gotoY;  // movement variables

    public:
    
    _snakeBody *firstBody;   // body
    _snakeTail snakeTail;    // tail
    
    int direction;    // direction (up, down, left, right)
    int speed;        // speed of the snake
    int x, y;         // (virtual) position of the (head of the) snake
    BITMAP *headBMP;  // head bitmap
    BITMAP *bodyBMP;  // body bitmap
    BITMAP *tailBMP;  // tail bitmap
    
    void init();        // Initializes the snake
    void destroy();     // Destroys the snake
    void createBody();  // Creates a new single body
    void deleteBodys(); // Deletes all bodys
    void moveBody();    // moves the body of the snake
    void move();        // moves the snake
    void draw();        // draws the snake
    bool bodyHitTest(); // checks for collision (body)
    
};








#endif
