// -------------------------------------------->>
// classicSnake
//
// Developed by: Alexandre Martins (@leX)
//  2003
// www.gamingbrasil.net
// =============================
// stage.h
// Object "stage" - header file
// -------------------------------------------->>

#ifndef STAGE_H
#define STAGE_H

// ----------------------->>
// Constants
// ----------------------->>
#define STAGE_DIR             "stages"
#define STAGE_CFGFILE         "stages.cfg"

// ------------------->>
// class _stage
// ------------------->>
class _stage{

    private:
    
    int bgRepeat_x;       // number of background repetitions
    int bgRepeat_y;       // number of background repetitions
    int number_of_stages; // number of stages



    public:
    
    BITMAP *background;   // background image
    MIDI *music;          // music
    
    int neededScore;      // needed score to go to next lv
    
    void loadStage(int s);  // loads stage s
    void deleteStage();     // deletes the current stage
    void drawBackground();  // draws the background into the screen
    void playMusic();       // plays the music of the current stage
    void drawStatus();      // draws status
    void advance();         // goto next stage
    
};

#endif
